#
# spec file for package opa-fm
#
# Copyright (c) 2016 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

%define pseudo_opt %{_prefix}/lib/opa-fm
%define opasysconfdir %{_sysconfdir}/opa/sysconfig
%define opavarlibdir %{_localstatedir}/usr/lib/opa-fm/
Name:           opa-fm
Version:        10.3.1
Release:        3.10
Summary:        Intel Omni-Path Fabric Management Software
License:        BSD-3-Clause
Group:          Development/Libraries/C and C++
Url:            http://www.intel.com/
Source:         opa-fm.tar.gz
Source1:        %{name}-rpmlintrc
Patch1:         0001-Fall-back-to-custom-vendor-if-os_vendor-fails.patch
Patch2:         opa-fm-use-RPM_OPT_FLAGS.patch
BuildRequires:  gcc-c++
BuildRequires:  rdma-core-devel
BuildRequires:  libexpat-devel
BuildRequires:  libibmad-devel
BuildRequires:  libopenssl-devel
BuildRequires:  ncurses-devel
BuildRequires:  tcl-devel
BuildRequires:  zlib-devel
Requires:       infiniband-diags
Requires:       rdma >= 12
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
#Currently ONLY builds on x86_64
ExclusiveArch:  x86_64

%description
The %{name} contains Intel Omni-Path fabric management applications. This
 includes: the Subnet Manager, Baseboard Manager, Performance Manager,
Fabric Executive, and some fabric management tools.

%prep
%setup -q -n %{name}
%patch1 -p1
%patch2 -p1

%build
export RPM_OPT_FLAGS
if [ -d Esm ]; then
	cd Esm
fi
./fmbuild -V %{version}.%{release}

%install
# directories
install -d -m0755 %{buildroot}%{opasysconfdir}
install -d -m0755 %{buildroot}%{opasysconfdir}/opa


install -D -m 644 stage.rpm/opafm.service %{buildroot}%{_prefix}/lib/systemd/system/opafm.service
install -D -m 755 stage.rpm/opafmctrl %{buildroot}/%{pseudo_opt}/bin/opafmctrl
install -D -m 755 stage.rpm/opafmd %{buildroot}/%{pseudo_opt}/bin/opafmd

%if 0%{?rhel} && 0%{?rhel} < 7
install -D -m 755 stage.rpm/opafm %{buildroot}%{_sysconfdir}/init.d/opafm
%endif

install -D -m 644 stage.rpm/opafm.xml  %{buildroot}%{opasysconfdir}/opafm.xml
install -D -m 644 stage.rpm/opafm.info %{buildroot}%{opasysconfdir}/opa/opafm.info

install -D stage.rpm/fm_capture %{buildroot}/%{pseudo_opt}/bin/fm_capture
install -D stage.rpm/fm_cmd %{buildroot}/%{pseudo_opt}/bin/fm_cmd
install -D stage.rpm/fm_cmdall %{buildroot}/%{pseudo_opt}/bin/fm_cmdall
install -D stage.rpm/smpoolsize %{buildroot}/%{pseudo_opt}/bin/smpoolsize

install -D stage.rpm/sm %{buildroot}/%{pseudo_opt}/runtime/sm
install -D stage.rpm/fe %{buildroot}/%{pseudo_opt}/runtime/fe

install -D stage.rpm/config_check %{buildroot}/%{pseudo_opt}/%{_sysconfdir}/config_check
install -D stage.rpm/config_convert %{buildroot}/%{pseudo_opt}/%{_sysconfdir}/config_convert
install -D stage.rpm/config_diff %{buildroot}/%{pseudo_opt}/%{_sysconfdir}/config_diff
install -D stage.rpm/config_generate %{buildroot}/%{pseudo_opt}/%{_sysconfdir}/config_generate
install -D stage.rpm/opafm %{buildroot}/%{pseudo_opt}/%{_sysconfdir}/opafm
install -D -m 644 stage.rpm/opafm.arch %{buildroot}/%{pseudo_opt}/%{_sysconfdir}/opafm.arch
install -D -m 644 stage.rpm/opafm.info %{buildroot}/%{pseudo_opt}/%{_sysconfdir}/opafm.info
if [ -d Esm ]; then
	sub_dir=Esm/
else
	sub_dir=
fi
install -D -m 644 ${sub_dir}ib/src/linux/startup/opafm_src.xml %{buildroot}/%{pseudo_opt}/%{_sysconfdir}/opafm_src.xml

install -D -m 644 stage.rpm/opafm.xml %{buildroot}/%{pseudo_opt}/%{_sysconfdir}/opafm.xml
install -D stage.rpm/opaxmlextract %{buildroot}/%{pseudo_opt}/%{_sysconfdir}/opaxmlextract
install -D stage.rpm/opaxmlfilter %{buildroot}/%{pseudo_opt}/%{_sysconfdir}/opaxmlfilter

mkdir -p %{buildroot}%{_sbindir}
mkdir -p %{buildroot}/opt
mkdir -p %{buildroot}%{_sysconfdir}/sysconfig/opa/
mkdir -p %{buildroot}%{opavarlibdir}
ln -s /%{pseudo_opt}/bin/fm_cmd %{buildroot}%{_sbindir}/opafmcmd
ln -s /%{pseudo_opt}/bin/fm_cmdall %{buildroot}%{_sbindir}/opafmcmdall
ln -s %{pseudo_opt} %{buildroot}/opt/
ln -s %{opasysconfdir}/opafm.xml  %{buildroot}%{_sysconfdir}/sysconfig/opafm.xml
ln -s %{opasysconfdir}/opa/opafm.info  %{buildroot}%{_sysconfdir}/sysconfig/opa/opafm.info

%pre
%service_add_pre opafm.service

%post
%service_add_post opafm.service

%preun
%service_del_preun opafm.service

%postun
%service_del_postun opafm.service

%files
%defattr(-,root,root,-)
%dir %{_sysconfdir}/opa
%dir %{opasysconfdir}
%dir %{pseudo_opt}/
%dir %{pseudo_opt}/bin
%dir %{pseudo_opt}/etc
%dir %{pseudo_opt}/runtime
%dir %{_sysconfdir}/sysconfig/opa
%{opasysconfdir}/*
/opt/opa-fm
%config /etc/opa/sysconfig/*

%doc README LICENSE

%{_prefix}/lib/systemd/system/opafm.service
%config(noreplace) %{_sysconfdir}/sysconfig/opafm.xml
%{_sysconfdir}/sysconfig/opa/opafm.info
%{pseudo_opt}/bin/*
%{pseudo_opt}%{_sysconfdir}/*
%{pseudo_opt}/runtime/*
%{_sbindir}/opafmcmd
%{_sbindir}/opafmcmdall

%changelog
* Fri May  5 2017 nmoreychaisemartin@suse.com
- Unify spec with SLE12.
- Reenable /opt directory (bsc#1036678).
* Fri Apr 28 2017 nmoreychaisemartin@suse.com
- Update path in /opt (bsc#1036678).
* Mon Apr  3 2017 josef.moellers@suse.com
- Removed a few unneeded dependencies to make rpmlint happy.
  Removed references to /var/usr/lib as it is not FHS.
* Wed Mar 29 2017 pth@suse.de
- Make dependencies on libs now coming from rdma-core versioned.
- Where feasable depend on rdma-core-devel.
* Thu Mar 16 2017 ndas@suse.de
- Add required package dependencies (bsc#1019151).
* Thu Mar 16 2017 josef.moellers@suse.com
- Modified spec file:
  * Removed some redudant code from %%post and %%preun
  * changed opa-fm.rpmlintrc to %%{name}.rpmlintrc
  * removed references to "/opt".
  * renamed opa-fm.rpmlintrc to opa-fm-rpmlintrc
* Tue Feb 28 2017 josef.moellers@suse.com
- Update to v10.3.1
  Unfortunately Intel has not shared any
  information related to the changes
  (fate#321479)
* Thu Jun  2 2016 ndas@suse.de
- Fixed misplaced opafm.info and opafm.xml to their peroper location
  (bsc#982810). This generates suse-filelist-forbidden-sysconfig error
  which requires a rpmlint file to suppress.
  [+opa-fm.rpmlintrc]
* Fri May 27 2016 ndas@suse.de
- Changed package directory(/opt/opafm) to /usr/lib/opafm and
  created a softlink /opt/opafm for the same, this partially fix
  osc warning suse-filelist-forbidden-opt(bsc#982045).
* Wed Mar  9 2016 ndas@suse.de
- Initial package, version: 10.0.0.0.697 (fate#319230)
